/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2005-2008 by TAKAGI Nobuhisa
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 */

/*!
 *  \file   toppers/text_line.hpp
 *  \brief  ƥȥǡιԤ˴ؤ
 *
 *  Υե륯饹
 *  \code
 *  struct text_line;
 *  struct basic_line_buf< CharT, Traits, Allocator >;
 *  \endcode
 */
#ifndef TOPPERS_TEXTLINE_HPP_
#define TOPPERS_TEXTLINE_HPP_

#include <iosfwd>
#include <string>
#include <algorithm>
#include "toppers/config.hpp"

namespace toppers
{

  /*!
   *  \struct text_line text_line.hpp "toppers/text_line.hpp"
   *  \brief  ե̾ȹֹݻ饹
   */
  struct text_line
  {
    std::string file;   //!< ե̾
    long line;          //!< ֹ1

    /*!
     *  \brief  ǥեȥ󥹥ȥ饯
     */
    text_line()
      : line( 0 )
    {
    }
    /*!
     *  \brief  󥹥ȥ饯
     *  \param  filename  ե̾
     *  \param  lineno    ֹ
     */
    explicit text_line( std::string const& filename, long lineno = 0 )
      : file( filename ), line( lineno )
    {
    }
    /*!
     *  \brief  󥹥ȥ饯
     *  \param  filename  ե̾
     *  \param  lineno    ֹ
     */
    explicit text_line( char const* filename, long lineno = 0 )
      : file( filename ), line( lineno )
    {
    }
    /*!
     *  \brief  ֥Ȥθ
     *  \param  other   оݤΥ֥
     */
    void swap( text_line& other ) throw()
    {
      std::swap( line, other.line );
      file.swap( other.file );
    }
  };

  /*!
   *  \struct line_buf text_line.hpp "toppers/text_line.hpp"
   *  \brief  1 ԥƥȤδ饹
   */
  template
  <
    typename CharT,
    class Traits = std::char_traits< CharT >,
    class Allocator = std::allocator< CharT >
  >
  struct basic_line_buf
  {
    typedef std::basic_string< CharT, Traits, Allocator > string_type;

    string_type buf; //!< ԥǡɽʸ
    text_line line;  //!< ֹ

    /*!
     *  \brief  ǥեȥ󥹥ȥ饯
     */
    basic_line_buf()
    {
    }
    /*!
     *  \brief  󥹥ȥ饯
     *  \param  line  ֹ
     */
    basic_line_buf( text_line const& line )
      : line( line )
    {
    }
    /*!
     *  \brief  󥹥ȥ饯
     *  \param  line  ֹ
     *  \param  data  ԥǡ
     */
    basic_line_buf( text_line const& line, string_type const& data )
      : buf( data ), line( line )
    {
    }
  };

  //! char Ǥ 1 ԥƥȴ饹
  typedef basic_line_buf< char > line_buf;

  /*!
   *  \brief  ƥ졼ݻֹμ
   *  \param  iter  ƥ졼
   *  \return ֹؤλȤ֤
   *
   *  iter ǻꤷƥ졼ֹݻƤʤ顢ιֹ֤ޤ
   *  ֹݻƤʤϥߡ֥ȤؤλȤ֤ޤ
   */
  template < class Iterator >
  inline text_line const& get_text_line( Iterator iter )
  {
    static text_line dummy;
    return dummy;
  }

}

#endif  // ! TOPPERS_TEXTLINE_HPP_
