/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2007-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_config.h 1598 2009-06-29 09:43:33Z ertl-honda $
 */

/*
 *  åȰ¸⥸塼SOI-SOCѡ
 *
 *  ͥΥåȰ¸Υ󥯥롼ɥե롥kernel_impl.hΥ
 *  åȰ¸ΰդȤʤ롥
 */

#ifndef TOPPERS_TARGET_CONFIG_H
#define TOPPERS_TARGET_CONFIG_H

/*
 *  åȥƥΥϡɥ񸻤
 */
#include "soisoc.h"

/*
 *  ȥ졼˴ؤ
 */
#ifdef TOPPERS_ENABLE_TRACE
#include "logtrace/trace_config.h"
#endif /* TOPPERS_ENABLE_TRACE */

#include "target_mmu.h"

/*
 *  åȰ¸ʸϤ˻ѤݡȤ
 */
#define TARGET_PUTC_PORTID 1

/*
 *  HRPͥưΥޥåפȴϢ
 *       
 *      0x8c000000 - 0x8cffffff ΰ(1MB)
 *      0x8c100000 -            ǡΰ(3MB)
 *                 - 0x8c3fffff Ωѥå
 *                 - 0x8e000000 꽪λ
 *
 */

/*
 *  ǥեȤ󥿥ƥѤΥåΰ
 */
#define DEFAULT_ISTKSZ    0x2000U

/*
 *  å⡼ɤ
 *    P1(0x8..)              : ԡХå
 *    P0(0x0..),U0,P3(0x3..) : ԡХå
 */
#define CCR_MODE    0x00000105

/*
 *  FPUΥХ󥯥쥸¸뤫
 */
//#define FPU_SAVE_BANKED_REG

#ifndef TOPPERS_MACRO_ONLY

/*
 *  åȥƥ¸ν
 */
extern void target_initialize(void);

/*
 *  åȥƥνλ
 *
 *  ƥλ˻Ȥ
 */
extern void target_exit(void) NoReturn;

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ԤΤSILΥåȰ¸
 */
#define SIL_DLY_TIM1     46
#define SIL_DLY_TIM2     25

#ifndef TOPPERS_MACRO_ONLY
// trapa㳰ϥɥ
extern void target_trapa_handler(void *p_excinf);

#define DEFAULT_SSTKSZ 2048 

/*
 *	ƥȥ֥å
 */
#define USE_TSKINICTXB	/*  TSKINICTXBѤ  */

typedef struct task_initialization_context_block {
	SIZE	sstksz;			/* åΰΥʴݤ᤿͡ */
	void	*sstk_bottom;	/* åݥ󥿤ν͡ʥåν͡ */
	SIZE	stksz;			/* åΰΥʴݤ᤿͡ */
	void	*stk_bottom;	/* åݥ󥿤ν͡ʥåν͡ */
} TSKINICTXB;

/*
 *  ݸɥᥤƥȥ֥å
 */

#define USE_DOMINICTXB	/*  TSKINICTXBѤ  */

typedef struct {
    uint32_t asid;
    void *page_table_info;
} DOMINICTXB;

/*
 *  桼ø⡼ɼ¹椫
 *  priv_modeϡӥ롢ӡĥӥ
 *  true˥åȤ
 */
#define t_sense_priv(p_tcb)   ((p_tcb)->tskctxb.priv_mode)
#define i_sense_priv(p_tcb)   ((p_tcb)->tskctxb.priv_mode)
#define t_sense_priv_runtsk() ((p_runtsk)->tskctxb.priv_mode)
#define i_sense_priv_runtsk() ((p_runtsk)->tskctxb.priv_mode)

#define USRTEX_STKSZ 16

extern bool_t i_check_tex_runtsk();

#endif /* TOPPERS_MACRO_ONLY */

#define NO_SVC 1        /* ӥƤӽФtrapaΰ */
#define NO_RET_TEX 2    /* ret_texƤӽФtrapaΰ */

/*
 *  ץå¸⥸塼SH34ѡ
 */
#include "sh34_gcc/sh7750r_config.h"

#ifdef CHECK_FUNC_ALIGN
#undef CHECK_FUNC_ALIGN
#define CHECK_FUNC_ALIGN 2
#endif /* CHECK_FUNC_ALIGN */

#define USE_REDZONE 1   /* RED ZONE Ȥ */

#endif  /* TOPPERS_TARGET_CONFIG_H */
